/**
 * @file 控件基类
 * @author hedongran
 * @email hdr01@126.com
 */
/// <reference types="react" />
import { Component, MapChildrenProps } from '../common';
export interface ControlProps extends MapChildrenProps {
    /** 控件的位置，可传下面4个参数： <br/>
     * BMAP\_ANCHOR\_TOP\_LEFT: 左上 <br/>
     * BMAP\_ANCHOR\_TOP\_RIGHT: 右上 <br/>
     * BMAP\_ANCHOR\_BOTTOM\_LEFT: 左下 <br/>
     * BMAP\_ANCHOR\_BOTTOM\_RIGHT: 右下 <br/>
     */
    anchor?: BMapGL.ControlAnchor;
    /** 控件的相对像素偏移量 */
    offset?: BMapGL.Size;
}
export default class Control<P extends ControlProps, S = {}, SS = any> extends Component<P, S, SS> {
    static defaultProps: ControlProps | object;
    static contextType: import("react").Context<import("../Map/Map").MapContextProps>;
    control: BMapGL.Control;
    options: string[];
    constructor(props: P);
    componentDidUpdate(prevProps: P): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    destroy(): void;
    initialize(): void;
    getControl(): BMapGL.Control;
}
