/**
 * @file 全景图层
 * @author hedongran [hdr01@126.com]
 */
/// <reference types="react" />
import { Component, MapChildrenProps } from '../common';
interface PanoramaLayerProps extends MapChildrenProps {
}
/**
 * 该组件用于展示全景蓝色路网图层，注意，该组件只展示蓝色路网，不包括进入全景图功能
 * @visibleName PanoramaLayer 全景图层
 */
export default class PanoramaLayer extends Component<PanoramaLayerProps> {
    static contextType: import("react").Context<import("../Map/Map").MapContextProps>;
    tilelayer: BMapGL.TileLayer;
    constructor(props: PanoramaLayerProps);
    componentDidMount(): void;
    componentDidUpdate(prevProps: PanoramaLayerProps): void;
    componentWillUnmount(): void;
    destroy(): void;
    initialize(): void;
    render(): null;
}
export {};
