/**
 * @file 地图自定义覆盖物组件
 * @author hedongran
 * @email hdr01@126.com
 */
/// <reference types="react" />
import { Component, MapChildrenProps } from '../common';
import { Options } from '../common/WrapperHOC';
interface CustomOverlayProps extends MapChildrenProps {
    /** 标注点的坐标 */
    position: BMapGL.Point;
    /** 坐标体系，可选百度经纬度坐标或百度墨卡托坐标 */
    coordType?: 'bd09ll' | 'bd09mc';
    /** 自动聚焦视野 */
    autoViewport?: boolean;
    /** 标注的偏移值 */
    offset?: BMapGL.Size;
    /** 元素的zIndex属性 */
    zIndex?: number;
    /** 标注的偏移单位，可选米或者像素 */
    unit?: 'm' | 'px';
}
/**
 * 在地图上通过传入DOM添加自定义覆盖物
 * @visibleName CustomOverlay 自定义覆盖物
 */
export default class CustomOverlay extends Component<CustomOverlayProps> {
    static contextType: import("react").Context<import("../Map/Map").MapContextProps>;
    overlay: BMapGL.Overlay;
    options: Options;
    constructor(props: CustomOverlayProps);
    componentDidUpdate(prevProps: CustomOverlayProps): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    destroy(): void;
    initialize(): void;
    parsePosition(position: BMapGL.Point): BMapGL.Point;
    render(): null;
}
export {};
