/**
 * @file 自定义覆盖物的DOM生成类
 * @author hedongran
 * @email hdr01@126.com
 */
/// <reference types="react" />
interface CustomOverlayOptions {
    html: React.ReactElement;
    offset?: BMapGL.Size;
    onClick(e: Event): void;
}
/**
 * 自定义覆盖物的DOM生成类
 * @param point 定位点坐标
 * @param options 传入参数，如offset等
 */
declare function CustomOverlayDom(this: any, point: BMapGL.Point, options: CustomOverlayOptions): void;
export default CustomOverlayDom;
