/**
 * @file 文本标注
 * @author hedongran
 * @email hdr01@126.com
 */
/// <reference types="react" />
import { Component, MapChildrenProps } from '../common';
import { Options } from '../common/WrapperHOC';
export interface LabelProps extends MapChildrenProps {
    /** 坐标体系，可选百度经纬度坐标或百度墨卡托坐标 */
    coordType?: 'bd09ll' | 'bd09mc';
    /** 文本标注的坐标 */
    position: BMapGL.Point;
    /** 设置文本标注的内容 */
    text: string;
    /** 文本标注的像素偏移 */
    offset?: BMapGL.Size;
    /** 设置文本标注的样式 */
    style?: {
        [name: string]: React.ReactText;
    };
    /** 鼠标左键单击事件的回调函数 */
    onClick?(e: Event): void;
    /** 鼠标左键双击事件的回调函数 */
    onDbclick?(e: Event): void;
    /** 鼠标右键单击事件的回调函数 */
    onRightclick?(e: Event): void;
    /** 鼠标指针移入Marker事件的回调函数 */
    onMouseover?(e: Event): void;
    /** 鼠标指针移出Marker事件的回调函数 */
    onMouseout?(e: Event): void;
}
declare class Label extends Component<LabelProps> {
    static contextType: import("react").Context<import("../Map/Map").MapContextProps>;
    static defaultProps: LabelProps | object;
    label: BMapGL.Label;
    options: Options;
    constructor(props: LabelProps);
    componentDidUpdate(prevProps: LabelProps): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    destroy(): void;
    initialize(): void;
    parsePosition(position: BMapGL.Point): BMapGL.Point;
    render(): null;
}
declare const _default: typeof Label;
/**
 *
 * @visibleName Label 文本标注
 */
export default _default;
