/**
 * @file 结果提示、自动完成类
 * @author hedongran [hdr01@126.com]
 */
import { CSSProperties } from 'react';
import { Component } from '../common';
import { Options } from '../common/WrapperHOC';
export interface AutoCompleteProps {
    /** 挂载的元素ID，若传值为空，则会自动生成一个input元素 */
    input?: string | HTMLElement;
    /** 设定返回结果的所属范围。例如“北京市” */
    location?: string;
    /** 挂载元素的样式 */
    style?: CSSProperties;
    /** 键盘或者鼠标移动，某条记录高亮之后，触发回调函数 */
    onHighlight?(e: Event): void;
    /** 回车选中某条记录后触发回调函数 */
    onConfirm?(e: Event): void;
    /** 在input框中输入字符后，发起列表检索，完成后的回调函数 */
    onSearchComplete?(e: Event): void;
}
declare class AutoComplete extends Component<AutoCompleteProps> {
    private el;
    static defaultProps: AutoCompleteProps | object;
    ac: BMapGL.Autocomplete;
    options: Options;
    constructor(props: AutoCompleteProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    destroy(): void;
    initialize(): void;
    render(): JSX.Element;
}
declare const _default: typeof AutoComplete;
/**
 * Autocomplete是结果提示、自动完成类，不依赖地图进行展示，是仅调用地图API的服务。
 * @visibleName AutoComplete 结果提示
 */
export default _default;
