/**
 * @file 地图各子组件的高阶组件，用来处理绑定事件、属性等公共操作
 * @author hedongran
 * @email hdr01@126.com
 */
import Component from './Component';
export declare type MapInstance = (BMapGL.Map | BMapGL.Overlay | BMapGL.Autocomplete | BMapGLLib.DrawingManager | BMapGLLib.DistanceTool);
export declare type Events = string[];
export declare type Options = string[];
export declare type Methods = {
    [x: string]: string[];
};
export declare function registerEvents(component: Component, instance: MapInstance, eventsMap?: Events): void;
export declare function unregisterEvents(component: Component, instance: MapInstance): void;
export declare function toggleMethods(component: Component, instance: MapInstance, methodsMap: Methods, prevProps?: {}): void;
export default function Wrapper<Comp>(Component: Comp, eventsMap?: Events, methodsMap?: Methods): Comp;
